# File: CatalogBrowser.py
# 
# Copyright (c) 2005 by 
# Generator: ArchGenXML Version 1.4.0-beta2 http://sf.net/projects/archetypes/
#
# GNU General Public Licence (GPL)
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
# details.
# You should have received a copy of the GNU General Public License along with
# this program; if not, write to the Free Software Foundation, Inc., 59 Temple
# Place, Suite 330, Boston, MA  02111-1307  USA
#
__author__  = '''unknown <unknown>'''
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *




from Products.CatalogBrowser.config import *
##code-section module-header #fill in your manual code here

from Products.CMFCore.utils import getToolByName
from ZTUtils import make_query

##/code-section module-header

schema=Schema((
    StringField('catalogname',
        default="portal_catalog",
        widget=StringWidget(
            label='Catalogname',
            label_msgid='CatalogBrowser_label_catalogname',
            description_msgid='CatalogBrowser_help_catalogname',
            i18n_domain='CatalogBrowser',
        )
    ),
    
    LinesField('listmetadatas',
        widget=InAndOutWidget(
            label='Listmetadatas',
            label_msgid='CatalogBrowser_label_listmetadatas',
            description_msgid='CatalogBrowser_help_listmetadatas',
            i18n_domain='CatalogBrowser',
        ),
        enforceVocabulary=1,
        multivalued="1",
        vocabulary="getDictAllMetadatasNames",
        required=1
    ),
    
),
)


##code-section after-schema #fill in your manual code here
##/code-section after-schema

class CatalogBrowser(BaseContent):
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)


    # This name appears in the 'add' box
    archetype_name             = 'CatalogBrowser'

    meta_type                  = 'CatalogBrowser' 
    portal_type                = 'CatalogBrowser' 
    allowed_content_types      = [] 
    filter_content_types       = 0
    global_allow               = 1
    allow_discussion           = 0
    content_icon               = 'book_icon.gif'
    immediate_view             = 'catalogbrowser_listing'
    default_view               = 'catalogbrowser_listing'
    typeDescription            = "A CatalogBrowser which provides special Navigation in a catalog"
    typeDescMsgId              = 'description_edit_catalogbrowser'

    actions =  (


       {'action':      "string:$object_url/catalogbrowser_listing",
        'category':    "object",
        'id':          'view',
        'name':        'catalogbrowser_listing',
        'permissions': ("View",),
        'condition'  : 'python:1'
       },
        

    )

    _at_rename_after_creation  = True 

    schema = BaseSchema + \
             schema

    ##code-section class-header #fill in your manual code here
    ##/code-section class-header


    #Methods

    security.declarePublic('getBrowserCatalogContents')
    def getBrowserCatalogContents(self, kw=None):
        """
        return result_type and a response-like query catalog        
        """
        result_type = 'nothing :S'
        catalog = getToolByName(self.portal_url.getPortalObject(), self.getCatalogname())
        if kw==None:
            kw = dict(self.REQUEST.form)
        thistype=''
        listtypes = []
        inbrowsing = False
        
        for i in kw.keys():
            if i in self.getListmetadatas() or i == 'listtypes':
                inbrowsing = True
        if not inbrowsing:
            listtypes = list(self.getListmetadatas())
        

        if kw.has_key('listtypes'):
            listtypes = kw['listtypes']
            del kw['listtypes']


        items = catalog.searchResults(kw)
        
    
        if len(listtypes) != 0:
            kw['listtypes'] =  listtypes[1:]
            thistype = listtypes[0]
            # unique values algo via dict
            u = {}
            for item in items:
                u[item[thistype]]=1
            results = u.keys()
            
            folderContents = []
            for result in results:
                kwresult = dict(kw)
                kwresult[thistype] = result
                i_listing = {}
                i_listing['kw'] = kwresult
                i_listing['absolute_url'] = self.absolute_url() + '?' + make_query(kwresult)
                i_listing['pretty_title_or_id'] = result
                i_listing['Description'] = result
                i_listing['id'] = result
                i_listing['portal_type'] = self.portal_type
                i_listing['Type'] = self.Type()
                i_listing['ModificationDate'] = self.ModificationDate()
                i_listing['CreationDate'] = self.CreationDate()
                i_listing['Creator'] = self.Creator()
                folderContents.append(i_listing)
                result_type = 'metadata_index'
            
        else:
            folderContents = items
            result_type = 'object_index'
            
        return (result_type, folderContents)



    security.declarePublic('getDictAllMetadatasNames')
    def getDictAllMetadatasNames(self):
        """
        return metadatas name of the catalog
        """
        catalog = getToolByName(self.portal_url.getPortalObject(), self.getCatalogname())
        indexes =  catalog.enumerateIndexes()
        simple_indexes = [i[0] for i in indexes]

        return simple_indexes



    security.declarePublic('getActualPath')
    def getActualPath(self, kw=None):
        """
        return actual virtual path : listtypes
        """
        if kw==None:
            kw = self.REQUEST.form
            kwcrumbs = dict(self.REQUEST.form)
        else:
            kwcrumbs = dict(kw)
        allmetadatas=self.getListmetadatas()
        breadcrumbs=[]
        visited_types=[]
        
        path_completed=True
        for m in allmetadatas:
            if not kw.has_key(m):
                path_completed=False
                
        for t in allmetadatas:
            if path_completed or (kw.has_key('listtypes') and t not in kw['listtypes']):
                visited_types.insert(0,t)

        
        i=len(visited_types)
        for visited in visited_types:
                kwcrumbs['listtypes'] = list(allmetadatas[i:])
                crumb={}
                crumb['kw'] = dict(kwcrumbs)
                crumb['Title'] = kw[visited]
                crumb['absolute_url'] = self.absolute_url() + '?' + make_query(kwcrumbs)
                breadcrumbs.insert(0,crumb)
                del kwcrumbs[visited]
                i=i-1
                
            
        
        return breadcrumbs



    security.declarePublic('getActualNavDict')
    def getActualNavDict(self):
        """
        
        """
        kw = dict(self.REQUEST.form)
        currentPath = self.getActualPath(kw=kw)
                
        # root path
        kwroot = {}
        pathroot = {}
        kwroot['listtypes'] = list(self.getListmetadatas())
        pathroot['kw'] = kwroot
        
 
        resultats = {'children': self.getBrowserCatalogContents(kw=pathroot['kw'])[1]}
        
        data = resultats
        for path in currentPath:
            (result_type, folderContents) = self.getBrowserCatalogContents(kw=path['kw'])
            if result_type == 'metadata_index':
                for r in data['children']:
                    if r['absolute_url'] == path['absolute_url']:
                        break
                r['children'] = folderContents
                data = r

                
        return resultats
    


def modify_fti(fti):
    # hide unnecessary tabs (usability enhancement)
    for a in fti['actions']:
        if a['id'] in ['metadata.sharing']:
            a['visible'] = 0
    return fti

registerType(CatalogBrowser,PROJECTNAME)
# end of class CatalogBrowser

##code-section module-footer #fill in your manual code here
##/code-section module-footer



